/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* 
 * File:   RealLtc2600.cpp
 * Author: C. Defrance
 * 
 * Created on 8 mars 2017, 17:26
 */
#include <stdio.h>

#include <cstring>

#include "RealLtc2600.h"

// Initialisation de l'attribut statique qui permet de savoir si la librairie
// bcm2835 a déjà été initialisée
int RealLtc2600::m_nbInstance = 0;

bool RealLtc2600::m_isCsAlreadyUsed[] = {false, false};

RealLtc2600::RealLtc2600(spiCS_t cs): ILtc2600(cs) {
    
    // On n'initialise la librairie que dans le cas où c'est la 1ère instanciation de RealLtc2600
    if( m_nbInstance == 0 ) {
        bcm2835_init();
        if( bcm2835_spi_begin() == 0) {
            printf("\nL'initialisation de la SPI a échouée. Avez-vous pensé à exécuter le programme avec `sudo` ?\n");
            exit(-1);
        } else {
            bcm2835_spi_setDataMode(BCM2835_SPI_MODE0); // CPOL=0 => SCLK à 0 à l'état repos, CPHA=0 => donnée transmise au 1ier front d'horloge

        }
    }
    
    if( m_isCsAlreadyUsed[ static_cast<int>(m_cs) ] == false) {
        m_isCsAlreadyUsed[ static_cast<int>(m_cs) ] = true;
    } else {
        printf("\nEchec de l'instanciation de RealLtc2600. Le chip select spécifié est déjà utilisé\n");
        exit(-1);          
    }
    
    if( m_nbInstance < 2) {
        m_nbInstance++;
    } else {
        printf("\nEchec de l'instanciation de RealLtc2600. Seuls 2 instances de RealLtc2600 peuvent coexister\n");
        exit(-1);       
    }
            
}

//ealLtc2600::RealLtc2600(const RealLtc2600& orig) {
//}

RealLtc2600::~RealLtc2600() {
    m_nbInstance--;
    
    m_isCsAlreadyUsed[ static_cast<int>(m_cs) ] = false;
    
    // On ferme la librairie ssi aucune instance de RealLtc2600 n'existe encore
    if (m_nbInstance == 0) {
        bcm2835_spi_end();
        bcm2835_close();
    }
}

int RealLtc2600::sendFrame(uint8_t * theData) {
    char rData[ 3 ];
    int spiCS = (m_cs == spiCS_t::CE0) ? BCM2835_SPI_CS0 : BCM2835_SPI_CS1;

    bcm2835_spi_chipSelect(spiCS);
    bcm2835_spi_setChipSelectPolarity(spiCS, LOW);
        
    bcm2835_spi_transfernb(reinterpret_cast<char *>(theData), rData, 3);
    
    //printf("datas reçues : 0x%02x - 0x%02x - 0x%02x\n", rData[0], rData[1], rData[2]);
    
    return  memcmp(theData, rData, 3) == 0 ? 0 : -1;
}
